
// ***********************************************
//
// * CONOUT - Ausgabe des Zeichen an den Monitor *
//
// ***********************************************


VAR
  Write_String : String[20];
  ESC_Sequenz_folgt : Boolean;
  Cursor_is_on : Boolean;
  Cursor_Byte : Byte;
  Cursor_Counter : Word;





procedure switch_Cursor_on;
begin
  Cursor_Byte:=BWS[BWS_Pos];
  BWS[BWS_Pos]:=$5F; // "_"
  Cursor_is_on:=true;
  Cursor_Counter:=0;
end switch_Cursor_on;





procedure switch_Cursor_off;
begin
  BWS[BWS_Pos]:=Cursor_Byte;
  Cursor_is_on:=false;
  Cursor_Counter:=0;
end switch_Cursor_off;




procedure switch_Cursor;
begin

  if Cursor_is_on then
    switch_Cursor_off;
  else
    switch_Cursor_on;
  endif;

end switch_Cursor;







procedure Schreibe_Zeichen_in_BWS(das_Byte : Byte);
begin
  BWS[BWS_Pos]:=das_Byte;

  if BWS_Pos<Laenge_BWS then
    Inc(BWS_Pos);
  endif;

end Schreibe_Zeichen_in_BWS;






procedure Screen_Roll_Up;
var
  w1 : Word;
  w2 : Word;
  w3 : Word;
  b1 : Byte;
begin

  w2:=Anzahl_Spalten;
  w3:=Laenge_BWS-Anzahl_Spalten;

  for w1:=0 to w3 do
    b1:=BWS[w2];
    BWS[w1]:=b1;
    Inc(w2);
  endfor;

  Inc(w3);

  for w1:=w3+1 to Laenge_BWS do
    BWS[w1]:=Fuellbyte;
  endfor;

end Screen_Roll_Up;





procedure berechne_LF;
var
  w1 : Word;
begin

  w1:=Laenge_BWS-Anzahl_Spalten;
  w1:=w1+1;

  if BWS_Pos<w1 then
    BWS_Pos:=BWS_Pos+Anzahl_Spalten;
  else
    Screen_Roll_Up;
    BWS_Pos:=w1;
  endif;

end berechne_LF;





procedure loesche_BWS;
var
  Zeichen_Zaehler : Word;
begin

  for Zeichen_Zaehler:=0 to Laenge_BWS do
    BWS[Zeichen_Zaehler]:=Fuellbyte;
  endfor; { for Zeichen_Zaehler:=0 to Laenge_BWS do }

  BWS_Pos:=0;

end loesche_BWS;





procedure berechne_CR;
var
  w1 : Word;
begin

  w1:=BWS_Pos div Anzahl_Spalten;
  BWS_Pos:=w1 * Anzahl_Spalten;

end berechne_CR;






procedure Schreibe_Byte_in_BWS(das_Byte : Byte);
begin


  if Cursor_is_on then
    switch_Cursor_off;
  endif;

  Cursor_Counter:=0;


  if ESC_Sequenz_folgt then


  else

    case das_Byte of

      $0A : berechne_LF;
       |

      $0C : loesche_BWS;
       |

      $0D : berechne_CR;
       |

      $1B : ESC_Sequenz_folgt:=true;
       |

      $20..$7F : Schreibe_Zeichen_in_BWS(das_Byte);
       |

    else
      Schreibe_Zeichen_in_BWS($3C);
      Schreibe_Zeichen_in_BWS(das_Byte);
      Schreibe_Zeichen_in_BWS($3E);
    endcase; // case das_Byte of


  endif; // if ESC_Sequenz_folgt then

end Schreibe_Byte_in_BWS;






procedure fuelle_BWS_mit_Zeichen;
var
  Zeichen_Zaehler : Word;
  das_Zeichen : Byte;
begin
  das_Zeichen:=0;
  BWS_Pos:=0;

  for Zeichen_Zaehler:=0 to Laenge_BWS do

    Schreibe_Zeichen_in_BWS(das_Zeichen);

    Inc(das_Zeichen);

  endfor; { for Zeichen_Zaehler:=0 to Laenge_BWS do }

end fuelle_BWS_mit_Zeichen;









procedure Write;
var
  c1 : Char;
  Laenge : Byte;
  b1 : Byte;
  b2 : Byte;
begin

  Laenge:=Length(Write_String);
  for b1:=1 to Laenge do
    c1:=Write_String[b1];
    b2:=CharToByte(c1);
    Schreibe_Byte_in_BWS(b2);
  endfor;

end Write;





procedure WriteLn;
begin
  Write;
  Schreibe_Byte_in_BWS($0D); // CR
  Schreibe_Byte_in_BWS($0A); // LF
end WriteLn;





procedure Init_CONOUT;
begin

  BWS_Pos:=0;
  ESC_Sequenz_folgt:=false;
  Cursor_is_on:=false;
  Cursor_Counter:=0;

//  fuelle_BWS_mit_Zeichen;

  loesche_BWS;

end Init_CONOUT;



                    
