PROGRAM TXTVGA2;

DEVICE = mega328p;

{$I mega328P_Register.INC}


CONST

  // Frequenz = 24.000.000 Hz;
  //CTC_WERT = 3175*24/100 -> 24.. ist Frequenz in MHz
  CTC_WERT : Word = 762;

  Laenge_BWS : Word = 1971; // 68*29 = 1..1972 oder 0..1971
  Anzahl_Spalten : Word = 68;

{$I VLINE.INC}

VAR

{
B0 - VSYNC  - A -> L
B1 - HSYNC  - A -> L
B2 - LED_GN - A -> L
B3 - CE_CLK - A -> L
B4 - S/L    - A -> L
}

  VSYNC[PortB,0]  : bit;    // VSYNC
  HSYNC[PortB,1]  : bit;    // HSYNC
  LED_GN[PortB,2] : bit;    // LED Gruen
  CE_CLK[PortB,3] : bit;    // CE_CLK
  SL[PortB,4]     : bit;    // Shift - /Load


{
D0..D7 - Daten fuer 74HC165
}


  Wert_yl, Wert_yh,
  Wert_zh, Wert_BWS_H, Wert_BWS_L,
  Fuellbyte : Byte;

  BWS : Array [0..Laenge_BWS] of Byte;
  BWS_Pos : Word;



{$I mega328P_TC.INC}



// *** INITIALISIERUNG ***


procedure InitPorts;
begin

{
B0 - VSYNC  - A -> L
B1 - HSYNC  - A -> L
B2 - LED_GN - A -> L
B3 - CE_CLK - A -> L
B4 - S/L    - A -> L
}
  //       EEEAAAAA
  DDRB:=  %00011111;

  // PORT B Voreinstellungen
  PORTB:= %00000000;


{
C0..C3 - Daten fuer ITP3

C4 - DS - E -> L
C5 - DR - E -> L
}
  // PORT C Voreinstellungen
  PortC:= %00000000;

  //       EEEEEEEE
  DDRC:=  %00000000;


{
D0..D7 - Daten fuer 74HC165 - alles Ausgaenge
}
  // PORT D Voreinstellungen
  PortD:= %00000000;

  //       AAAAAAAA
  DDRD:=  %11111111;


end InitPorts;





isr TIMER1_COMPA;
begin

{$I VIDEO.INC}

end TIMER1_COMPA;





{$I CONOUT.INC}

{$I ITP3_CLI_PORT.INC}
{$I ITP3_CLI_PRG.INC}





BEGIN


  InitPorts;


  SetBit(SL);

  ClearBit(VSYNC);
  ClearBit(HSYNC);


  Init_TIMER1_COMPA(CTC_WERT);

  Wert_yl:=0;
  Wert_yh:=0;

  // Fuellbyte:=$2E;    // .
  Fuellbyte:=$20;

  Wert_zh:=16;



ASM;

 ldi   R16, low(BWS)
 sts   Wert_BWS_L, R16

 ldi   R16, high(BWS)
 sts   Wert_BWS_H, R16

ENDASM;


  Init_CONOUT;

  EnableInts;


  loop

    ITP3_Server_Abfrage;

    INC(Cursor_Counter);

    if Cursor_Counter=10000 then
      switch_Cursor;
    endif;


  endloop;


{$I font8x16.INC}

END TXTVGA2.
